'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _node = require('./util/node');

var _node2 = _interopRequireDefault(_node);

var _returnvalue = require('./util/returnvalue');

var _returnvalue2 = _interopRequireDefault(_returnvalue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file dom node 用于在headless里查询某个特定的dom的node
 * 
 * @author liyinan
 * @version 1.0
 * @date 2017-07-23
 */

var DomExists = function (_Node) {
    (0, _inherits3.default)(DomExists, _Node);

    function DomExists() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, DomExists);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DomExists.__proto__ || (0, _getPrototypeOf2.default)(DomExists)).call.apply(_ref, [this].concat(args))), _this), _this.dep = ['chrome'], _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(DomExists, [{
        key: 'exec',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(param, context) {
                var chrome, selector, doc, _ref3, nodeId;

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                (0, _get3.default)(DomExists.prototype.__proto__ || (0, _getPrototypeOf2.default)(DomExists.prototype), 'exec', this).call(this, param, context);
                                chrome = context.getService('chrome');
                                selector = this.options.selector;
                                _context.next = 5;
                                return chrome.DOM.getDocument();

                            case 5:
                                doc = _context.sent;
                                _context.next = 8;
                                return chrome.DOM.querySelector({
                                    nodeId: doc.root.nodeId,
                                    selector: selector
                                });

                            case 8:
                                _ref3 = _context.sent;
                                nodeId = _ref3.nodeId;
                                return _context.abrupt('return', new _returnvalue2.default(0, !!nodeId, this));

                            case 11:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function exec(_x, _x2) {
                return _ref2.apply(this, arguments);
            }

            return exec;
        }()
    }]);
    return DomExists;
}(_node2.default);

DomExists.type = 'domexists';
DomExists.declaration = {
    selector: {
        type: 'string'
    }
};
exports.default = DomExists;