'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _executable = require('./util/executable');

var _executable2 = _interopRequireDefault(_executable);

var _util = require('./util/util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 为什么Flow extends node呢？
 * 因为SubFlow需要继承Flow，而SubFlow需要可以被node调用，可以输出到node，从泛化上讲就是一个node
 * 从合理性上讲，应该是node和flow都实现一个executable的interface，但是这是nodejs，不是java，只好这样实现了
 *
 * 续：我终于忍不了，写了一个executable class 来为可执行的数据结构提供接口
 * 此事完结
 */
var Flow = function (_Executable) {
    (0, _inherits3.default)(Flow, _Executable);

    function Flow() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, Flow);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Flow.__proto__ || (0, _getPrototypeOf2.default)(Flow)).call.apply(_ref, [this].concat(args))), _this), _this.nodes = [], _this.links = [], _this.context = {
            service: {}
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    // 这里不对subflow进行展开，只包含当前flow的内容


    (0, _createClass3.default)(Flow, [{
        key: 'checkDep',
        value: function checkDep() {}
    }, {
        key: 'exec',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(param, context) {
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.next = 2;
                                return (0, _get3.default)(Flow.prototype.__proto__ || (0, _getPrototypeOf2.default)(Flow.prototype), 'exec', this).call(this, param, context);

                            case 2:
                                return _context.abrupt('return', (0, _util.asyncFlowRunner)(this));

                            case 3:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function exec(_x, _x2) {
                return _ref2.apply(this, arguments);
            }

            return exec;
        }()
    }, {
        key: 'dispose',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
                var _this2 = this;

                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                _context3.next = 2;
                                return (0, _get3.default)(Flow.prototype.__proto__ || (0, _getPrototypeOf2.default)(Flow.prototype), 'dispose', this).call(this);

                            case 2:
                                return _context3.abrupt('return', _promise2.default.all(this.nodes.map(function () {
                                    var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(node) {
                                        return _regenerator2.default.wrap(function _callee2$(_context2) {
                                            while (1) {
                                                switch (_context2.prev = _context2.next) {
                                                    case 0:
                                                        return _context2.abrupt('return', node.dispose());

                                                    case 1:
                                                    case 'end':
                                                        return _context2.stop();
                                                }
                                            }
                                        }, _callee2, _this2);
                                    }));

                                    return function (_x3) {
                                        return _ref4.apply(this, arguments);
                                    };
                                }())));

                            case 3:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function dispose() {
                return _ref3.apply(this, arguments);
            }

            return dispose;
        }()

        /**
         * 添加一个新node
         *
         * @param {Node} newNode node
         */

    }, {
        key: 'addNode',
        value: function addNode(newNode) {
            var exist = nodes.find(function (node) {
                return (0, _util.equal)(node, newNode);
            });
            if (!exist) {
                nodes.push(newNode);
            }
        }

        /**
         * 移除一个node
         *
         * @param {Node} rmNode node
         */

    }, {
        key: 'removeNode',
        value: function removeNode(rmNode) {
            var index = nodes.findIndex(function (node) {
                return (0, _util.equal)(node, rmNode);
            });
            var node = nodes[index];
            if (index !== -1) {
                nodes.splice(index, 1);
            }
        }
    }, {
        key: 'removeLink',
        value: function removeLink(fromId, toId) {
            if (!fromId && !toId) {
                return;
            }
            var links = this.links;
            if (fromId) {
                // 使用原始数组筛选
                links = links.filter(function (link) {
                    return link.fromId === fromId;
                });
            }
            if (toId) {
                // 使用 筛选过的数组筛选
                links = links.filter(function (link) {
                    return link.toId === toId;
                });
            }
            if (links.length) {
                this.links = this.links.filter(function (link) {
                    return link !== links[0];
                });
            }
        }
    }, {
        key: 'addLink',
        value: function addLink(newLink) {
            var link = this.links.find(function (link) {
                return link.fromId === newLink.fromId && link.toId === newLink.toId;
            });
            if (link) {
                return;
            }
            this.links.push(link);
        }
    }]);
    return Flow;
}(_executable2.default);

Flow.type = 'flow';
exports.default = Flow;