'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _node = require('./util/node');

var _node2 = _interopRequireDefault(_node);

var _returnvalue = require('./util/returnvalue');

var _returnvalue2 = _interopRequireDefault(_returnvalue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file switch node 用于对数据进行条件判断的node
 * 
 * @author liyinan
 * @version 1.0
 * @date 2017-07-26
 */

var Transform = function (_Node) {
    (0, _inherits3.default)(Transform, _Node);

    function Transform(config) {
        (0, _classCallCheck3.default)(this, Transform);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Transform.__proto__ || (0, _getPrototypeOf2.default)(Transform)).call(this, config));

        _this.out = config.options.conditions.length;
        return _this;
    }

    (0, _createClass3.default)(Transform, [{
        key: 'exec',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(param, context) {
                var conditions, params, code, toPort, codes, func;
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                (0, _get3.default)(Transform.prototype.__proto__ || (0, _getPrototypeOf2.default)(Transform.prototype), 'exec', this).call(this, param, context);
                                conditions = this.options.conditions || [];
                                params = this.options.params || [];
                                code = '';
                                toPort = void 0;
                                _context.prev = 5;

                                if (params.length) {
                                    // 把用户指定的参数名从arguments里解构出来
                                    code = 'let [' + params.join(',') + '] = arguments;' + code;
                                }
                                // 生成每个条件的判断代码
                                codes = conditions.map(function (cond, index) {
                                    return '\n                if (' + cond + ') {\n                    return ' + index + ';\n                }\n            ';
                                });

                                code += codes.join('');
                                // 所有条件都没match会抛一个错误
                                code += 'throw \'no matched switch, param: \' + JSON.stringify(arguments)';
                                func = new Function(code);

                                toPort = func(param);
                                _context.next = 18;
                                break;

                            case 14:
                                _context.prev = 14;
                                _context.t0 = _context['catch'](5);

                                console.log(_context.t0);
                                throw _context.t0;

                            case 18:
                                return _context.abrupt('return', new _returnvalue2.default(toPort, param, this));

                            case 19:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this, [[5, 14]]);
            }));

            function exec(_x, _x2) {
                return _ref.apply(this, arguments);
            }

            return exec;
        }()
    }]);
    return Transform;
}(_node2.default);

Transform.type = 'switch';
Transform.declaration = {
    params: {
        type: 'array.string'
    },
    conditions: {
        type: 'array.string'
    }
};
exports.default = Transform;