'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get3 = require('babel-runtime/helpers/get');

var _get4 = _interopRequireDefault(_get3);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _node = require('./node');

var _node2 = _interopRequireDefault(_node);

var _lodash = require('lodash');

var _context2 = require('./context');

var _context3 = _interopRequireDefault(_context2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var VirtualNode = function (_Node) {
    (0, _inherits3.default)(VirtualNode, _Node);

    function VirtualNode(returnValue) {
        (0, _classCallCheck3.default)(this, VirtualNode);

        var _this = (0, _possibleConstructorReturn3.default)(this, (VirtualNode.__proto__ || (0, _getPrototypeOf2.default)(VirtualNode)).call(this));

        _this.name = 'virtualnode';
        _this.type = 'virtualnode';

        var originNode = returnValue.node;
        // 把virtual node 伪装成原始node
        var exec = _this.exec;
        (0, _lodash.merge)(_this, originNode);
        // 还原exec方法
        _this.exec = function () {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            var context = args[args.length - 1];
            if (context instanceof _context3.default) {
                context.newScope();
            }
            return exec.call.apply(exec, [_this].concat(args));
        };
        // 改改名字吧，不然都分不清是真的node还是virtual node
        _this.name = 'virtual node ' + _this.name;
        _this.returnValue = returnValue;
        return _this;
    }

    (0, _createClass3.default)(VirtualNode, [{
        key: 'exec',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
                var _get2;

                for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                    args[_key2] = arguments[_key2];
                }

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                (_get2 = (0, _get4.default)(VirtualNode.prototype.__proto__ || (0, _getPrototypeOf2.default)(VirtualNode.prototype), 'exec', this)).call.apply(_get2, [this].concat(args));
                                return _context.abrupt('return', this.returnValue);

                            case 2:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function exec() {
                return _ref.apply(this, arguments);
            }

            return exec;
        }()
    }]);
    return VirtualNode;
}(_node2.default); /**
                    * @file 有些node并非只有一次输出，而是需要不断地产生结果
                    * 例如定时器、koa的router
                    * 这个类作为一个包装，可以返回一个不断产生结果的击发器
                    * 在产生新的结果时可以像普通node一样继续执行后续步骤
                    * 
                    * @author liyinan
                    * @version 1.0
                    * @date 2017-08-02
                    */

var ContinuousOutput = function () {
    function ContinuousOutput() {
        (0, _classCallCheck3.default)(this, ContinuousOutput);
        this.cache = [];
        this.callbacks = [];
    }

    (0, _createClass3.default)(ContinuousOutput, [{
        key: 'output',
        value: function output(returnValue) {
            this.cache.push(returnValue);
            this.doOutput();
        }
    }, {
        key: 'onoutput',
        value: function onoutput(callback) {
            this.callbacks.push(callback);
        }
    }, {
        key: 'doOutput',
        value: function doOutput() {
            if (!this.callbacks.length) {
                return;
            }
            var ret = void 0;
            while (ret = this.cache.shift()) {
                // 回调传入一个伪装成原始node 的virtual node
                // 这样可以顺着这个virtual node继续执行原始node的后续node
                this.callbacks.map(function (callback) {
                    return callback(new VirtualNode(ret));
                });
            }
        }
    }]);
    return ContinuousOutput;
}();

exports.default = ContinuousOutput;